package cc.smtweb.system.bpm.web.engine.dynPage;

import cc.smtweb.framework.core.common.SwException;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.mvc.service.AbstractHandler;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.system.bpm.web.design.form.ModelFormHelper;
import cc.smtweb.system.bpm.web.design.form.define.PageDataSet;

import java.util.Map;

/**
 * Created by Akmm at 2022/4/21 17:53
 */
public abstract class AbstractDynPageHandler extends AbstractHandler {
    //页面定义id
    protected long pageId;
    protected Map<String, PageDataSet> mapDataset;

    @Override
    public void init(SwMap params, UserSession us) {
        super.init(params, us);
        pageId = params.readLong("pageId");

        mapDataset = ModelFormHelper.parsePageDataset(pageId);
        if (mapDataset == null) throw new SwException("没有找到页面定义数据！");
    }

    protected PageDataSet findDataset(String name) {
        return mapDataset.get(name);
    }

    //获取第一个，主数据集
    protected PageDataSet findMasterDataset() {
        for (PageDataSet dataSet: mapDataset.values()) {
            return dataSet;
        }
        return null;
    }
}
