package cc.smtweb.system.bpm.web.engine.dynPage;

import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.annotation.SwBody;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.framework.core.mvc.service.*;
import cc.smtweb.framework.core.session.UserSession;

/**
 * Created by Akmm at 2022/4/21 17:43
 * 动态页面引擎
 */
@SwService
public class DynPageService extends AbstractCompService {
    public final static String TYPE_ADD = "add";

    @Override
    protected IHandler createHandler(String type) {
        switch (type) {
            case TYPE_ADD:
                return new DynPageAddHandler();
            case TYPE_LOAD:
                return new DynPageLoadOneHandler();
            case TYPE_SAVE:
                return new DynPageSaveHandler();
            case TYPE_DEL:
                return new DynPageDelHandler();
        }
        return null;
    }

    //新增
    public R add(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_ADD);
    }

    //保存指定数据集
    public R saveOne(@SwBody SwMap params, UserSession us) {
        try {
            DynPageSaveHandler handler = (DynPageSaveHandler) getHandler(params, us, TYPE_SAVE);
            return handler.saveOne();
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }

    //删除指定数据集
    public R delOne(@SwBody SwMap params, UserSession us) {
        try {
            DynPageDelHandler handler = (DynPageDelHandler) getHandler(params, us, TYPE_DEL);
            return handler.delOne();
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }

    //列表总记录数及合计栏
    public R total(@SwBody SwMap params, UserSession us) {
        try {
            DynPageLoadOneHandler handler = (DynPageLoadOneHandler) getHandler(params, us, TYPE_LOAD);
            return handler.getTotal();
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }
}
